	include		"calc.h"

	include		"doorsos.h"
	include		"macros.h"
	include		"hexlib.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment

S_X		EQU	5
S_Y		EQU	8+5+3
S_W		EQU	12
S_H		EQU	11
X_INDENT	EQU	2
Y_INDENT	EQU	2
WINDOW_WIDTH	EQU	3*S_W+2*5
WINDOW_HEIGHT	EQU	S_Y+3*S_H+4

WINDOW2_WIDTH	EQU	62
WINDOW2_HEIGHT	EQU	28

_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	600
	DEFINE_PROSIT_EVENT	"moub",Event_Mousebutton
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	move.b		#0,Window1+W_FLAGS
	move.b		#0,Window1+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		w1rect(pc)			;*Window dimensions
	move.l		#Window1,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

	move.b		#2,Player

Restart:
	pea		w1gui	(pc)
	move.l		#Window1,-(sp)
	jsr		winlib::DrawStructure
	addq.l		#8,sp

	clr.w		Window2+W_CONTENTS_HANDLE
	move.l		#field,a6
	move.l		#0,(a6)
	move.l		#0,4(a6)
	move.b		#0,8(a6)

Main_Loop:
	neg.b		Player
	add.b		#3,Player

	move.w		#0,-(sp)
	move.l		#Window1,-(sp)
	jsr		doorsos::WinFont
	addq.l		#6,sp
	move.b		#A_REPLACE,Window1+W_TEXT_LINE_ATTRIBUTES

	move.b		#"X",d0
	cmp.b		#1,Player
	beq.s		\iscr
	move.b		#"O",d0
\iscr	move.b		d0,turnply
	pea		turnstr(pc)
	move.w		#9,-(sp)		;Y
	move.w		#S_X,-(sp)		;X
	move.l		#Window1,-(sp)		;Window
	jsr		doorsos::WinStrXY
	jsr		winlib::Refresh_Window
	lea		12(sp),sp

\sleep	jsr		Prosit::Sleep
	tst.w		MouseButton
	blt.s		\sleep

	lea		winners(pc),a0
	moveq		#7,d6
	moveq		#0,d5
	move.b		Player,d2
\loop	move.b		(a0)+,d5
	cmp.b		0(a6,d5.w),d2
	beq.s		\ok1		;First in line checks out
	addq.l		#2,a0
	bra.s		\next
\ok1	move.b		(a0)+,d5
	cmp.b		0(a6,d5.w),d2
	beq.s		\ok2		;Second in line checks out
	addq.l		#1,a0
	bra.s		\next
\ok2	move.b		(a0)+,d5
	cmp.b		0(a6,d5.w),d2
	beq		Winner		;Third in line checks out - we have a winner!
\next	dbra.s		d6,\loop

	moveq		#9-1,d6
\check	tst.b		0(a6,d6.w)
	beq		Main_Loop
	dbra.s		d6,\check


	move.l		#tiestr,winptr
	bra		WinSc

Winner:
	move.l		#winstr,winptr
	move.b		#"X",winstrc
	cmp.b		#1,Player
	beq		WinSc
	move.b		#"O",winstrc
WinSc:
	eor.b		#WF_LOCKED,Window1+W_FLAGS	;Lock the main window

	move.b		#0,Window2+W_FLAGS
	move.b		#0,Window2+W_PRIORITY
	pea		window2(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		w2rect(pc)			;*Window dimensions
	move.l		#Window2,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

\slp	jsr		Prosit::Sleep
	cmp.w		#1024,MouseButton
	bne.s		\slp

	move.l		#Window2,-(sp)
	jsr		winlib::WinClose
	addq.l		#4,sp

	eor.b		#WF_LOCKED,Window1+W_FLAGS	;Unlock the main window

	bra		Restart


Event_Mousebutton:
	movem.l		a6/d0-d1/d7,-(sp)

	tst.w		Window2+W_CONTENTS_HANDLE
	bne		\done
	move.w		MouseButton,d0
	blt		\done

	move.w		d0,d1
	and.w		#%0000000011111111,d0	;X
	lsr.w		#8,d1			;Y

	move.w		d1,d7
	mulu.w		#3,d7
	add.w		d0,d7

	move.l		#field,a6
	tst.b		0(a6,d7.w)
	beq.s		\free			;Square is free

	move.w		#-1,MouseButton		;Signal that player attempted something wrong
	bra.s		\done

\free	move.b		Player,0(a6,d7.w)

	mulu.w		#S_W,d0
	mulu.w		#S_H,d1
	add.w		#S_X+X_INDENT,d0
	add.w		#S_Y+Y_INDENT,d1

	move.w		#A_NORMAL,-(sp)
	pea		cross(pc)		;*gfx (if player=cross)
	cmp.b		#1,Player
	beq.s		\iscr
	move.l		#circle,(sp)		;*gfx (if player=circle)
\iscr	move.w		d1,-(sp)		;Y
	move.w		d0,-(sp)		;X
	move.l		#Window1,-(sp)		;Window
	jsr		doorsos::WinBitmapPut
	jsr		winlib::Refresh_Window
	lea		14(sp),sp

\done	movem.l		(sp)+,a6/d0-d1/d7
	rts


_exit:
Event_Quit:
	tst.w		Window2+W_CONTENTS_HANDLE
	beq.s		\quit
	move.l		#Window2,-(sp)
	jsr		winlib::WinClose
	addq.l		#2,sp
\quit	move.l		#Window1,-(sp)
	jsr		winlib::WinClose
	move.w		Prosit::CurrentProcessID,(sp)
	jsr		Prosit::Process_Terminate

;***********************************************************************

winners:
	dc.b	0,3,6
	dc.b	1,4,7
	dc.b	2,5,8
	dc.b	0,1,2
	dc.b	3,4,5
	dc.b	6,7,8
	dc.b	0,4,8
	dc.b	2,4,6

	EVEN
w1rect	dc.w	10,30,10+WINDOW_WIDTH-1,30+WINDOW_HEIGHT-1
w2rect	dc.w	5,45,5+WINDOW2_WIDTH-1,45+WINDOW2_HEIGHT-1




;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	w1gui	;Window GUI list
lwgotf	dc.l	w1foc	;"Window got focus" list
lwlostf	dc.l	w1nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w1gui	dc.l	w1gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w1gfx
	dc.l	w1s11
	dc.w	0+RF_TRIG_RELEASE
	dc.l	w1s12
	dc.w	1+RF_TRIG_RELEASE
	dc.l	w1s13
	dc.w	2+RF_TRIG_RELEASE
	dc.l	w1s21
	dc.w	256+RF_TRIG_RELEASE
	dc.l	w1s22
	dc.w	257+RF_TRIG_RELEASE
	dc.l	w1s23
	dc.w	258+RF_TRIG_RELEASE
	dc.l	w1s31
	dc.w	512+RF_TRIG_RELEASE
	dc.l	w1s32
	dc.w	513+RF_TRIG_RELEASE
	dc.l	w1s33
	dc.w	514+RF_TRIG_RELEASE
	dc.l	0

;GUI GRAPHICAL PART
w1gfx	dc.b	R_RECT,0,0,0,WINDOW_WIDTH-1,WINDOW_HEIGHT-1
	dc.w	A_NORMAL
w1s11	dc.b	R_BUTTON,0,S_X,S_Y,S_X+S_W-1,S_Y+S_H-1
	dc.w	EMPTY_BUTTON
w1s12	dc.b	R_BUTTON,0,S_X+S_W,S_Y,S_X+2*S_W-1,S_Y+S_H-1
	dc.w	EMPTY_BUTTON
w1s13	dc.b	R_BUTTON,0,S_X+2*S_W,S_Y,S_X+3*S_W-1,S_Y+S_H-1
	dc.w	EMPTY_BUTTON
w1s21	dc.b	R_BUTTON,0,S_X,S_Y+S_H,S_X+S_W-1,S_Y+2*S_H-1
	dc.w	EMPTY_BUTTON
w1s22	dc.b	R_BUTTON,0,S_X+S_W,S_Y+S_H,S_X+2*S_W-1,S_Y+2*S_H-1
	dc.w	EMPTY_BUTTON
w1s23	dc.b	R_BUTTON,0,S_X+2*S_W,S_Y+S_H,S_X+3*S_W-1,S_Y+2*S_H-1
	dc.w	EMPTY_BUTTON
w1s31	dc.b	R_BUTTON,0,S_X,S_Y+2*S_H,S_X+S_W-1,S_Y+3*S_H-1
	dc.w	EMPTY_BUTTON
w1s32	dc.b	R_BUTTON,0,S_X+S_W,S_Y+2*S_H,S_X+2*S_W-1,S_Y+3*S_H-1
	dc.w	EMPTY_BUTTON
w1s33	dc.b	R_BUTTON,0,S_X+2*S_W,S_Y+2*S_H,S_X+3*S_W-1,S_Y+3*S_H-1
	dc.w	EMPTY_BUTTON
	dc.b	-1

	EVEN
;"GOT FOCUS" LIST - FIRST ELEMENT
w1foc	dc.l	w1foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w1fgfx
	dc.l	w1fgfx
	dc.w	0+RF_TRIG_RELEASE+RF_QUIT
	dc.l	w1ft
	dc.w	-1
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w1fgfx	dc.b	R_BUTTON,0,0,0,6,6
	dc.w	PL_CENTERED+BU_FRAMED_BLACK+BU_GFX+A_REPLACE
	dc.l	clopen,clclose
w1ft	dc.b	R_BUTTON,0,7,1,WINDOW_WIDTH-2,6
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_FILLED_BLACK+A_REVERSE+BU_SMALL_FONT
	dc.b	"TicTacToe",0

	dc.b	-1

	EVEN
;"LOST FOCUS" LIST - FIRST ELEMENT
w1nofoc	dc.l	w1nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w1lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w1lfgfx	dc.b	R_FILL,0,1,1,WINDOW_WIDTH-2,5
	dc.w	A_XOR
	dc.b	-1



	EVEN
;WINDOW #2 STRUCTURE
window2:
lw2gui	dc.l	w2gui	;Window GUI list
lw2gotf	dc.l	w2foc	;"Window got focus" list
lw2lost	dc.l	w2nofoc	;"Window lost focus" list

;GUI LIST - FIRST ELEMENT
w2gui	dc.l	w2gui	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank

;GUI MANAGEMENT PART
	dc.l	w2gfx
	dc.l	w2fgfx
	dc.w	-1
	dc.l	w2b1
	dc.w	1024+RF_TRIG_RELEASE
	dc.l	0

;GUI GRAPHICAL PART
w2gfx	dc.b	R_RECT,0,0,0,WINDOW2_WIDTH-1,WINDOW2_HEIGHT-1
	dc.w	A_NORMAL
	dc.b	R_BUTTON,0,5,9,WINDOW2_WIDTH-6,14
	dc.w	BU_TEXT+PL_CENTERED+A_NORMAL+BU_SMALL_FONT
winptr	dc.l	winstr

w2b1	dc.b	R_BUTTON,0,3,WINDOW2_HEIGHT-12,WINDOW2_WIDTH-4,WINDOW2_HEIGHT-4
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"OK",0,0
	dc.b	-1

	EVEN
;"GOT FOCUS" LIST - FIRST ELEMENT
w2foc	dc.l	w2foc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"GOT FOCUS" MANAGEMENT PART
	dc.l	w2fgfx
	dc.l	0
;"GOT FOCUS" GRAPHICAL PART
w2fgfx	dc.b	R_BUTTON,0,1,1,WINDOW2_WIDTH-2,6
	dc.w	PL_LEFT_TOP+BU_TEXT+BU_FILLED_BLACK+A_REVERSE+BU_SMALL_FONT
	dc.b	"Message",0
	dc.b	-1

	EVEN
;"LOST FOCUS" LIST - FIRST ELEMENT
w2nofoc	dc.l	w2nofoc	;Only element in list => points to itself
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;"LOST FOCUS" MANAGEMENT PART
	dc.l	w2lfgfx
	dc.l	0
;"LOST FOCUS" GRAPHICAL PART
w2lfgfx	dc.b	R_FILL,0,1,1,WINDOW2_WIDTH-2,5
	dc.w	A_XOR
	dc.b	-1

tiestr	dc.b	"It's a tie!",0
winstr	dc.b	"The winner is "
winstrc	dc.b	"X",0

turnstr	dc.b	"Turn: "
turnply	dc.b	"X",0

;turn_x	dc.b	"Turn: X",0
;turn_o	dc.b	"Turn: O",0

	EVEN
clopen	dc.w	5,5
	dc.b	%11111000
	dc.b	%10101000
	dc.b	%11011000
	dc.b	%10101000
	dc.b	%11111000
	EVEN
clclose	dc.w	5,5
	dc.b	%00000000
	dc.b	%01010000
	dc.b	%00100000
	dc.b	%01010000
	dc.b	%00000000

cross	dc.w	7,8
	dc.b	%11000011
	dc.b	%01100110
	dc.b	%00111100
	dc.b	%00011000
	dc.b	%00111100
	dc.b	%01100110
	dc.b	%11000011

circle	dc.w	7,8
	dc.b	%00011000
	dc.b	%01111110
	dc.b	%11100111
	dc.b	%11000011
	dc.b	%11100111
	dc.b	%01111110
	dc.b	%00011000

_comment
	dc.b	"Prosit: Tic-tac-toe",0

	BSS
Window1		ds.b	W_HEADER_SIZE
Window2		ds.b	W_HEADER_SIZE

field		ds.b	9
Player		dc.b	0

Window_Datareturn:
Key		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
	CODE

	END
