;********************
;*                  *
;* HEADER FUNCTIONS *
;*                  *
;********************

;---------------------------------------------------------------------
; BYTE *Header_Get(WORD filehandle)
;
; Function: Get the header of a Prosit file.
;
; Output: a0 = *header, 0 if none found.
;---------------------------------------------------------------------
Header_Get:
prosit@0000:
	movem.l		d0,-(sp)

	move.w		4+1*4(sp),d0	;File handle
	doorsos::DEREF	d0,a0
	addq.l		#2,a0
	cmp.l		#"68kP",4(a0)		;Assembly program?
	bne.s		\none
	cmp.w		#$4E75,(a0)		;First instruction is RTS?
	bne.s		\none
	move.w		2(a0),d0
	lea		0(a0,d0.w),a0	;*_prosit
	bra.s		\done
\none	move.l		#0,a0

\done	movem.l		(sp)+,d0
	rts

;---------------------------------------------------------------------
; BYTE *Header_FindField(BYTE *current, WORD type)
;
; Function: Find the next header field of <type> in a Prosit header.
;  Call with a pointer to the header to find the first field.
;  Call repeatedly with the return value to find subsequent fields.
;
; Output: a0 = *field, 0 if none found.
;---------------------------------------------------------------------
Header_FindField:
prosit@0001:
	movem.l		d0-d1,-(sp)

	move.l		4+2*4(sp),a0	;*Current
	move.w		4+2*4+4(sp),d0	;type
	moveq		#0,d1
\next	move.b		(a0),d1
	beq.s		\none
	lea		0(a0,d1.w),a0
	cmp.b		1(a0),d0
	beq.s		\done
	bra.s		\next
\none	move.l		#0,a0

\done	movem.l		(sp)+,d0-d1
	rts
