	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"
	include		"prosit.h"
	include		"winlib.h"
	include		"keycodes.h"

	xdef		_prosit
	xdef    	_main
	xdef		_exit
	xdef		_comment

WINW			EQU	SCREEN_WIDTH
WINH			EQU	11
WINX			EQU	0
WINY			EQU	SCREEN_HEIGHT-WINH

BUTW			EQU	7
BUTH			EQU	9

BUTXFOM			EQU	0
BUTXFOL			EQU	BUTXFOM+BUTW+1
BUTWFOL			EQU	6*8+3
BUTXFOP			EQU	BUTXFOL+BUTWFOL+1

BUTXFIM			EQU	BUTXFOP+BUTW+2
BUTXPRG			EQU	BUTXFIM+BUTW+1
BUTWPRG			EQU	6*8+3
BUTXFIP			EQU	BUTXPRG+BUTWPRG+1

BUTXQ			EQU	BUTXFIP+BUTW+4
BUTWQ			EQU	20

BUTY			EQU	2
TEXTY			EQU	4

BUTXO			EQU	1
BUTQXO			EQU	3
BUTYO			EQU	2

_prosit:
	HEADER_BEGIN
	DEFINE_PROSIT_VERSION	PROSIT_VERSION_STRING
	DEFINE_PROSIT_FILETYPE	PROSIT_FILETYPE_PROGRAM
	DEFINE_PROSIT_STACKSIZE	0
	DEFINE_PROSIT_EVENT	"moub",Event_Mousebutton
	DEFINE_PROSIT_EVENT	"quit",Event_Quit
	HEADER_END

_main:
	jsr		winlib::Init_Window_System

	move.b		#0,Window+W_FLAGS
	move.b		#127,Window+W_PRIORITY
	pea		window1(pc)			;*Structure
	move.l		#Window_Datareturn,-(sp)	;*Return
	pea		winrect(pc)			;*Window dimensions
	move.l		#Window,-(sp)			;*Window
	jsr		winlib::WinOpen
	lea		16(sp),sp

;Set window background parameters
	move.b		#%00000000,Window+W_BACKGROUND_ATTRIBUTES
;Set the window text/line attributes
	move.b		#A_NORMAL,Window+W_TEXT_LINE_ATTRIBUTES
;Set the window client region
	move.l		#$0000ef6e,Window+W_CLIENT_REGION_X1
;Set the window clip region
	move.l		#$0000ef6e,Window+W_CLIP_REGION_X1
;Set the window font
	move.w		#0,-(sp)
	move.l		#Window,-(sp)
	jsr		doorsos::WinFont
	lea		6(sp),sp

	move.w  	#8,d0
	doorsos::DEREF 	d0,a0
	move.l		a0,FolderListAdress
	move.w		2(a0),Folders
	move.w		#0,d0
	bsr		DrawFolder

	move.l		sp,StoredSP		;So that Event_Quit will work OK
\sleep	jsr		Prosit::Sleep
	bra.s		\sleep


;***********************************************************************

NextFolder:
	move.w		CurrentFolder,d0
	addq.w		#1,d0
	cmp.w		Folders,d0
	bne		DrawFolder
	moveq		#0,d0
	bra		DrawFolder

PreviousFolder:
	move.w		CurrentFolder,d0
\again	subq.w		#1,d0
	bge		DrawFolder
	move.w		Folders,d0
	bra.s		\again

DrawFolder:
	move.w		d0,CurrentFolder
	move.l		FolderListAdress,a0
	mulu.w		#14,d0
	lea		4(a0,d0.w),a0
	bsr		PlotFolder
	move.w		12(a0),d0
	doorsos::DEREF	d0,a0
	move.l		a0,FolderAdress
	move.w		2(a0),Files

FindFirstFile:
	tst.w		Files
	beq		NoFirstFile
	move.w		#0,CurrentFile
	bra		FindNextFile
NoFirstFile:
	move.w		#-1,CurrentFile
	lea		empty(pc),a0
	bsr		PlotFile
	rts

FindPreviousFile:
	moveq		#-1,d6
	move.w		#-14,d7
	bra		FindFile
FindNextFile:
	moveq		#1,d6
	move.w		#14,d7
FindFile:
	tst.w		CurrentFile
	blt		\done
	move.l		FolderAdress,a1
	move.w		CurrentFile,d0
\rest	move.w		d0,d1
	muls.w		#14,d0
\loop	add.w		d7,d0			;Next file offset
	add.w		d6,d1			;Next file
	bge.s		\ok1
	move.w		Files,d0
	subq.w		#1,d0
	bra.s		\rest
\ok1	cmp.w		Files,d1
	blt.s		\ok2
	moveq		#0,d0
	moveq		#0,d1
\ok2	cmp.w		CurrentFile,d1		;Have we gone checked all files?
	beq		NoFirstFile		;Yes, no Prosit file in this folder!

	move.w		4+12(a1,d0.w),-(sp)	;File handle
	jsr		Prosit::Header_Get
	addq.l		#2,sp
	cmp.l		#0,a0
	beq.s		\loop			;No _prosit header

	move.w		#PROSIT_VERSION,-(sp)
	move.l		a0,-(sp)
	jsr		Prosit::Header_FindField
	cmp.l		#0,a0
	beq.s		\nope			;No PROSIT_VERSION field
	cmp.w		#PROSIT_VERSION_STRING,2(a0)
	bne.s		\nope			;Wrong Prosit version

	move.w		#PROSIT_FILETYPE,4(sp)
	jsr		Prosit::Header_FindField
	addq.l		#6,sp
	cmp.l		#0,a0
	beq.s		\loop			;No PROSIT_FILETYPE field

	cmp.l		#$70726F62,4(a1,d0.w)	;Compare with "prob"
	bne.s		\notpb
	cmp.l		#$6F6F7400,4+4(a1,d0.w)	;Compare with "oot "
	beq.s		\loop

\notpb	move.w		2(a0),CurrentFileType
	move.w		d1,CurrentFile
	lea		4(a1,d0.w),a0		;*Filename
	move.w		12(a0),CurrentFileHandle
	bsr		PlotFile
\done	rts

\nope	addq.l		#6,sp
	bra		\loop


PlotFolder:
	movem.l		a0,-(sp)
	move.l		a0,folsptr
	move.l		#wbfol,-(sp)
	bra		Plot
PlotFile:
	movem.l		a0,-(sp)
	move.l		a0,prgsptr
	move.l		#wbprg,-(sp)
Plot:
	move.l		#Window,-(sp)
	jsr		winlib::DrawStructureObject
	jsr		winlib::Refresh_Window
	addq.l		#8,sp
	movem.l		(sp)+,a0
	rts

;***********************************************************************

Event_Mousebutton:
	cmp.w		#1,Folders
	beq.s		\onefol		;Only one folder, ignore folder buttons
	cmp.w		#1,MouseButton
	beq		PreviousFolder
	cmp.w		#2,MouseButton
	beq		NextFolder
\onefol	cmp.w		#3,MouseButton
	beq		FindPreviousFile
	cmp.w		#4,MouseButton
	beq		FindNextFile
	cmp.w		#5,MouseButton
	bne.s		\done

	tst.w		CurrentFile
	blt.s		\done			;No files in folder!
	move.w		CurrentFileHandle,-(sp)
	cmp.w		#PROSIT_FILETYPE_PROGRAM,CurrentFileType
	bne.s		\notprg
	jsr		Prosit::Process_New
	bra.s		\skip
\notprg	cmp.w		#PROSIT_FILETYPE_BACKGROUND,CurrentFileType
	bne.s		\done
	jsr		winlib::Load_Background_Image
\skip	addq.w		#2,sp

\done	rts

;***********************************************************************

_exit:
Event_Quit:
	move.l		#default,folsptr
	move.l		#default,prgsptr

	move.l		StoredSP,sp	;Restore stack pointer to main program's

;Tell all other processes to quit:
	BROADCAST_EVENT	#"quit"

;Wait for them to actually do it:
	move.w		Prosit::CurrentProcessID,d0
	doorsos::DEREF	d0,a0
\loop	move.l		(a0),a1		;*2nd process
	move.l		(a1),a1		;*3rd process
	cmp.l		(a1),a0		;*4th process = *1st proecss?
	bne.s		\loop		;No, keep waiting

;Close my own window:
	move.l		#Window,-(sp)
	jsr		winlib::WinClose
	addq.l		#4,sp

;Close down the window system:
	jsr		winlib::Close_Window_System

	rts				;Return to Prosit:s init routines and quit to TIOS.

;***********************************************************************


	EVEN
;WINDOW #1 STRUCTURE
window1:
lwgui	dc.l	wgui	;Window GUI list
lwgotf	dc.l	0	;"Window got focus" list - none in this case
lwlostf	dc.l	0	;"Window lost focus" list - none in this case

;WINDOW GUI LIST - FIRST ELEMENT
wgui	dc.l	wgui
	dc.w	0	;ID
	dc.b	127	;Priority
	dc.b	0	;Blank
;MANAGEMENT PART #1
	dc.l	wgfx
	dc.l	wbq
	dc.w	0+RF_QUIT+RF_TRIG_RELEASE
	dc.l	wbfom
	dc.w	1+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	wbfop
	dc.w	2+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	wbfim
	dc.w	3+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	wbprg
	dc.w	5+RF_TRIG_RELEASE
	dc.l	wbfip
	dc.w	4+RF_TRIG_FIRST+RF_TRIG_REPEAT
	dc.l	0
;GRAPHICAL PART #1
wgfx	dc.b	R_LINE,0,0,0,WINW-1,0
	dc.w	A_NORMAL
wbq	dc.b	R_BUTTON,0,BUTXQ,BUTY,BUTXQ+BUTWQ-1,BUTY+BUTH-1
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"QUIT",0,0
wbfom	dc.b	R_BUTTON,0,BUTXFOM,BUTY,BUTXFOM+BUTW-1,BUTY+BUTH-1
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"<",0
wbfol	dc.b	R_BUTTON,0,BUTXFOL,BUTY,BUTXFOL+BUTWFOL-1,BUTY+BUTH-1
	dc.w	PL_CENTERED+BU_TEXT+BU_FILLED_WHITE+A_NORMAL+BU_SMALL_FONT
folsptr	dc.l	default
wbfop	dc.b	R_BUTTON,0,BUTXFOP,BUTY,BUTXFOP+BUTW-1,BUTY+BUTH-1
	dc.w	SMALL_TEXT_BUTTON
	dc.b	">",0
wbfim	dc.b	R_BUTTON,0,BUTXFIM,BUTY,BUTXFIM+BUTW-1,BUTY+BUTH-1
	dc.w	SMALL_TEXT_BUTTON
	dc.b	"<",0
wbprg	dc.b	R_BUTTON,0,BUTXPRG,BUTY,BUTXPRG+BUTWPRG-1,BUTY+BUTH-1
	dc.w	SMALL_TEXT_BUTTON
prgsptr	dc.l	default
wbfip	dc.b	R_BUTTON,0,BUTXFIP,BUTY,BUTXFIP+BUTW-1,BUTY+BUTH-1
	dc.w	SMALL_TEXT_BUTTON
	dc.b	">",0
	dc.b	-1

default	dc.b	" ",0



_comment
	dc.b	"Prosit: Boot",0

empty	dc.b	"<empty>",0


	EVEN
winrect	dc.w	WINX,WINY,WINX+WINW-1,WINY+WINH-1

	BSS
Window	ds.b	W_HEADER_SIZE


StoredSP		dc.l	0

Folders			dc.w	0
Files			dc.w	0
FolderListAdress	dc.l	0
CurrentFolder		dc.w	0
FolderAdress		dc.l	0
CurrentFile		dc.w	0
CurrentFileType		dc.w	0
CurrentFileHandle	dc.w	0

Window_Datareturn:
WKey		dc.w	0
MouseWindow	dc.w	0
MouseButton	dc.w	0
MouseX		dc.w	0
MouseY		dc.w	0
Status		dc.w	0

	CODE

	END
