	include		"calc.h"

	include		"doorsos.h"
	include		"hexlib.h"
	include		"macros.h"

	include		"prosit.h"

	include		"keycodes.h"

	xdef		_library

	xdef		winlib@0000	;Init_Window_System
	xdef		winlib@0001	;Load_Background_Image
	xdef		winlib@0002	;Close_Window_System

	xdef		winlib@0003	;MouseX
	xdef		winlib@0004	;MouseY

	xdef		winlib@0005	;WinOpen
	xdef		winlib@0006	;WinClose
	xdef		winlib@0007	;WinSelect
	xdef		winlib@0008	;Move_Window
	xdef		winlib@0009	;Refresh_Window
	xdef		winlib@000A	;Move_Window_To_Front

	xdef		winlib@000C	;Clear
	xdef		winlib@000D	;SetClip
	xdef		winlib@000E	;VertLine
	xdef		winlib@000F	;HorizLine
	xdef		winlib@0010	;Box
	xdef		winlib@0011	;PlotGFX

	xdef		winlib@0015	;DrawStructure
	xdef		winlib@0016	;DrawStructureItem
	xdef		winlib@0017	;DrawStructureObject

W_TI_FLAGS		EQU	$00
W_FONT			EQU	$02
W_TEXT_LINE_ATTRIBUTES	EQU	$03
W_BACKGROUND_ATTRIBUTES	EQU	$04
W_BLANK			EQU	$05
W_OWNER			EQU	$06
W_CUR_X			EQU	$08
W_CUR_Y			EQU	$0A
W_CURSOR_X		EQU	$0C
W_CURSOR_Y		EQU	$0E
W_CLIENT_REGION_X1	EQU	$10
W_CLIENT_REGION_Y1	EQU	$11
W_CLIENT_REGION_X2	EQU	$12
W_CLIENT_REGION_Y2	EQU	$13
W_X_POS			EQU	$14
W_Y_POS			EQU	$16
W_CLIP_REGION_X1	EQU	$18
W_LEFT_CLIP		EQU	W_CLIP_REGION_X1
W_CLIP_REGION_Y1	EQU	$19
W_TOP_CLIP		EQU	W_CLIP_REGION_Y1
W_CLIP_REGION_X2	EQU	$1A
W_RIGHT_CLIP		EQU	W_CLIP_REGION_X2
W_CLIP_REGION_Y2	EQU	$1B
W_BOTTOM_CLIP		EQU	W_CLIP_REGION_Y2
W_WIDTH			EQU	$1C
W_HEIGHT		EQU	$1E
W_CONTENTS_HANDLE	EQU	$20
;WINDOW "HEADER" FOR THE WINDOW LIST
W_HEADER		EQU	$22
W_NEXT			EQU	$22
W_ID			EQU	$26
W_PRIORITY		EQU	$28
W_FLAGS			EQU	$29
;TIOS STRUCTURE ENDS HERE
W_EXTRA_DATA		EQU	$30
W_WIDTH_IN_WORDS	EQU	$30
W_STRUCTURE		EQU	$32
;HIDDEN DATA
W_HD			EQU	$36
W_DATARETURN		EQU	W_HD	;Adress to window datareturn area
W_SHIFTED_HANDLE	EQU	W_HD+4	;Handle of gfx to plot
W_MASK_HANDLE		EQU	W_HD+6	;Handle of refresh mask
;FOR SHIFTING
W_SH			EQU	W_HD+8
W_Y_OFFSET_IN_CONTENTS	EQU	W_SH	;Offset within contents
W_VISIBLE_ROWS		EQU	W_SH+2	;How many columns to shift per row
W_VISIBLE_COLUMNS	EQU	W_SH+4	;How many rows to shift
W_ROWADD_CONTENTS	EQU	W_SH+6	;RowAdd for contents/mask
W_ROWADD_LCD		EQU	W_SH+8	;RowAdd for the LCD
W_SHIFT_AMOUNT		EQU	W_SH+10	;How much to shift each word
W_LCD_START_OFFSET	EQU	W_SH+12	;Where to start plotting on the LCD
W_X_OFFSET_IN_CONTENTS	EQU	W_SH+14	;Offset within mask
W_SHIFTED_WIDTH		EQU	W_SH+16
W_HEADER_SIZE		EQU	W_SH+18
W_EXTRA_HEADER_SIZE	EQU	W_HEADER_SIZE-W_EXTRA_DATA

WF_ACTIVE		EQU	%00000001
WFB_ACTIVE		EQU	0
WF_LOCKED		EQU	%00000010
WFB_LOCKED		EQU	1


W_DR_KEY		EQU	0
W_DR_MOUSE_WINDOW	EQU	W_DR_KEY+2
W_DR_MOUSE_BUTTON	EQU	W_DR_MOUSE_WINDOW+2
W_DR_MOUSE_X		EQU	W_DR_MOUSE_BUTTON+2
W_DR_MOUSE_Y		EQU	W_DR_MOUSE_X+2

F_NORMAL	EQU	0
F_DIMMED	EQU	1
F_BOLD		EQU	2
F_UNDERLINED	EQU	4
F_INVERTED	EQU	8
F_ITALIC	EQU	16

L_BLACK		EQU	2
L_WHITE		EQU	0
LB_COLOR	EQU	1
L_USES_PATTERN	EQU	1
LB_USES_PATTERN	EQU	0

B_TOP_WHITE		EQU	%0000000000000010
B_TOP_BLACK		EQU	%0000000000000011
B_TOP_PATTERN		EQU	%0000000000000001
B_BOTTOM_WHITE		EQU	%0000000000001000
B_BOTTOM_BLACK		EQU	%0000000000001100
B_BOTTOM_PATTERN	EQU	%0000000000000100
B_LEFT_WHITE		EQU	%0000000000100000
B_LEFT_BLACK		EQU	%0000000000110000
B_LEFT_PATTERN		EQU	%0000000000010000
B_RIGHT_WHITE		EQU	%0000000010000000
B_RIGHT_BLACK		EQU	%0000000011000000
B_RIGHT_PATTERN		EQU	%0000000001000000
B_FILLED_WHITE		EQU	%0000001000000000
B_FILLED_BLACK		EQU	%0000001100000000
B_FILLED_PATTERN	EQU	%0000000100000000
B_FRAMED_BLACK	EQU	B_TOP_BLACK+B_BOTTOM_BLACK+B_LEFT_BLACK+B_RIGHT_BLACK
B_FRAMED_WHITE	EQU	B_TOP_WHITE+B_BOTTOM_WHITE+B_LEFT_WHITE+B_RIGHT_WHITE

BB_TOP_WHITE		EQU	%00000010
BB_TOP_BLACK		EQU	%00000011
BB_TOP_PATTERN		EQU	%00000001
BB_BOTTOM_WHITE		EQU	%00001000
BB_BOTTOM_BLACK		EQU	%00001100
BB_BOTTOM_PATTERN	EQU	%00000100
BB_LEFT_WHITE		EQU	%00100000
BB_LEFT_BLACK		EQU	%00110000
BB_LEFT_PATTERN		EQU	%00010000
BB_RIGHT_WHITE		EQU	%10000000
BB_RIGHT_BLACK		EQU	%11000000
BB_RIGHT_PATTERN	EQU	%01000000
BB_FILLED_WHITE		EQU	%00000010
BB_FILLED_BLACK		EQU	%00000011
BB_FILLED_PATTERN	EQU	%00000001
BB_FRAMED_BLACK	EQU	BB_TOP_BLACK+BB_BOTTOM_BLACK+BB_LEFT_BLACK+BB_RIGHT_BLACK
BB_FRAMED_WHITE	EQU	BB_TOP_WHITE+BB_BOTTOM_WHITE+BB_LEFT_WHITE+BB_RIGHT_WHITE

INT5_ADDRESS		EQU	$74

;SCREEN_WIDTH		EQU	240
;SCREEN_HEIGHT		EQU	128


	PROSIT_LOCK_HEADER	1

;---------------------------------------------------------------------
; Init_Window_System(void)
;
; Function: Initialize Window system
;---------------------------------------------------------------------
Init_Window_System:
winlib@0000:
	movem.l		a0-a2/d0-d2,-(sp)

	clr.l		WindowInFocus
	clr.l		WindowInFocus_Return
	clr.l		WindowInFocus_Structure

	clr.l		WindowList

	clr.b		msin
	move.b		#1,msout

;Hook mouse coordinate interrupt to auto-int 5
	clr.b		mDelay
	move.w		#$0700,d0
	trap		#1
	move.l		INT5_ADDRESS,old_int5
	bclr.b		#2,$600001
	move.l		#Mouse_Interrupt,INT5_ADDRESS
	bset.b		#2,$600001
	trap		#1

;Initiate "mouse" thread
	pea		Mouse_Process(pc)		;*code
	pea		Mouse_Process_Header(pc)	;*header
	jsr		Prosit::Process_Fork
	move.w		d0,mid
	addq.l		#8,sp

;Initiate "mousebutton" thread
	pea		Mousebutton_Process(pc)		;*code
	pea		Mousebutton_Process_Header(pc)	;*header
	jsr		Prosit::Process_Fork
	move.w		d0,mbid
	addq.l		#8,sp

;Wait for "mouse" thread to initialize
\wait	BREAK_AND_COOPERATE
	tst.b		msout
	bne.s		\wait

;Initiate background window
	move.b		#0,BkgWindow+W_FLAGS
	move.b		#-127,BkgWindow+W_PRIORITY
	clr.l		-(sp)			;Has no structure
	clr.l		-(sp)			;*Return = 0 (TEMPORARY!)
	pea		BkgWinRect(pc)		;*Dimensions
	pea		BkgWindow(pc)		;*Window
	bsr		WinOpen
	lea		16(sp),sp
	move.w		BkgWindow+W_CONTENTS_HANDLE,BkgWindowContentsHandle
	move.w		BkgWindow+W_MASK_HANDLE,BkgWindowMaskHandle

	movem.l		(sp)+,a0-a2/d0-d2
	rts

;---------------------------------------------------------------------
; Load_Background_Image(WORD filehandle)
;
; Function: Load a background image. The current image will be
;  replaced. If filehandle=0 the image will be blank.
;---------------------------------------------------------------------
Load_Background_Image:
winlib@0001:
	movem.l		a1/d0,-(sp)

	move.w		BkgWindow+W_CONTENTS_HANDLE,d0
	doorsos::DEREF	d0,a1			;*Background
	addq.l		#4,a1
	move.w		4+2*4(sp),-(sp)		;Image handle
	bne.s		\load

;Handle=0 - clear the background
\clear	nop
	bra.s		\done

;Handle>0 - load a background image
\load	jsr		Prosit::Execute_File

;Done, refresh background window
\done	move.l		#BkgWindow,-(sp)
	bsr		Refresh_Window
	addq.l		#2+4,sp

	movem.l		(sp)+,a1/d0
	rts

;---------------------------------------------------------------------
; Close_Window_System(void)
;
; Function: Close and de-allocate all remaining windows.
;---------------------------------------------------------------------
Close_Window_System:
winlib@0002:
	movem.l		a0-a2/d0-d2,-(sp)

;Terminate mouse and mousebutton threads
	move.w		mid,-(sp)
	jsr		Prosit::Process_Terminate
	move.w		mbid,(sp)
	jsr		Prosit::Process_Terminate

;Close background window
	move.l		#BkgWindow,-(sp)
	bsr		WinClose
;	bsr		Destroy_Window
	addq.l		#2+4,sp

;Remove mouse coordinate interrupt hook
	move.w		#$0700,d0
	trap		#1
	bclr.b		#2,$600001
	move.l		old_int5,INT5_ADDRESS
	bset.b		#2,$600001
	trap		#1

	movem.l		(sp)+,a0-a2/d0-d2
	rts

;---------------------------------------------------------------------
; BOOL WinOpen(WINDOW *w, WIN_RECT *dimensions, WIN_RETURN *wr,
;  WIN_STRUCTLIST *s)
;
; Function: Open the window with fixed dimensions using the flags set
;  within <w>.
;
; Return: d0 = 0 if success, -1 if not enough memory.
;---------------------------------------------------------------------
WinOpen:
winlib@0005:
	movem.l		a0-a3/d1-d3,-(sp)

	move.l		4+7*4+0(sp),a3		;*Window
	move.l		4+7*4+4(sp),a2		;*Dimensions

	clr.b		W_FLAGS(a3)				;Flags
	move.w		Prosit::CurrentProcessID,W_OWNER(a3)	;Owner
	movem.w		(a2),d0-d3

	move.w		d0,W_X_POS(a3)			;X Position
	move.w		d1,W_Y_POS(a3)			;Y position

	sub.w		d0,d2
	sub.w		d1,d3
	clr.b		W_LEFT_CLIP(a3)		;Left clip = 0
	clr.b		W_CLIENT_REGION_X1(a3)
	clr.b		W_TOP_CLIP(a3)		;Top clip = 0
	clr.b		W_CLIENT_REGION_Y1(a3)
	move.b		d2,W_RIGHT_CLIP(a3)	;Right clip = width-1
	move.b		d2,W_CLIENT_REGION_X2(a3)
	move.b		d3,W_BOTTOM_CLIP(a3)	;Bottom clip = height-1
	move.b		d3,W_CLIENT_REGION_Y2(a3)
	addq.w		#1,d2			;Width in pixels
	move.w		d2,W_WIDTH(a3)
	addq.w		#1,d3			;Height in pixels
	move.w		d3,W_HEIGHT(a3)

	move.l		4+7*4+8(sp),a2				;*Return
	move.l		a2,W_DATARETURN(a3)
	beq.s		\retzro
	clr.l		(a2)				;Clear last key pressed and mousebutton
\retzro	move.l		4+7*4+12(sp),W_STRUCTURE(a3)

	subq.w		#1,d2
	lsr.w		#4,d2			;Width/16
	addq.w		#1,d2			;Upper(Width/16)

	move.w		d2,d1			;Needed in two calculations
	addq.w		#1,d1			;Shifted data and Window mask needs one more column

	move.w		d2,W_WIDTH_IN_WORDS(a3)
	lsl.w		#1,d2			;2*Upper(Width/16)
	lsl.w		#1,d1			;Shifted data is both GFX and Mask

	mulu.w		d3,d2			;Memory for Contents
	addq.l		#4,d2			;To make the bitmap TIOS-compatible
	addq.w		#1,d3		;Preliminary mask row
	mulu.w		d1,d3			;Memory for Shifted Data/Window mask

	TOGGLE_PROSIT
	move.l		d2,-(sp)
	jsr		doorsos::HeapAllocHigh
	move.w		d0,W_CONTENTS_HANDLE(a3)
	beq.s		\fail0
	move.l		d3,(sp)
	jsr		doorsos::HeapAllocHigh
	move.w		d0,W_SHIFTED_HANDLE(a3)
	beq.s		\fail1
	jsr		doorsos::HeapAllocHigh
	move.w		d0,W_MASK_HANDLE(a3)
	bne.s		\ok
;Not enough memory for third block
\fail2
	move.w		W_SHIFTED_HANDLE(a3),(sp)
	jsr		doorsos::HeapFree
;Not enough memory for second block
\fail1
	move.w		W_CONTENTS_HANDLE(a3),(sp)
	jsr		doorsos::HeapFree
;Not enough memory for first block
\fail0	moveq		#-1,d0
\ok	addq.l		#4,sp
	TOGGLE_PROSIT

	tst.w		d0
	blt		\done

	move.w		#WF_DONT_REALLOC+WF_VISIBLE,W_TI_FLAGS(a3)
	move.b		#A_NORMAL,W_TEXT_LINE_ATTRIBUTES(a3)
	move.b		#A_REVERSE,W_BACKGROUND_ATTRIBUTES(a3)

	subq.l		#8,sp
	move.l		a3,(sp)			;*Window
	bsr		WinSelect
	jsr		doorsos::WinClr		;Clear window
	move.l		W_STRUCTURE(a3),a1
	cmp.l		#0,a1
	beq.s		\nogui			;Window has no structure
	move.l		(a1),a1			;Window GUI list
	cmp.l		#0,a1
	beq.s		\nogui			;Window has no GUI
	move.l		a1,4(sp)
	bsr		DrawStructure		;Draw GUI
\nogui	addq.l		#8,sp

	bsr		Clear_Window_Focus	;Remove focus from whatever window that has it.
	move.l		a3,a0
	bsr		Make_Window_Focus	;The opened window ends up in the front right away.

	PROSIT_LOCK	1

;	move.w		d6,W_ID(a0)		;List entry ID
;	move.b		4+8*4+4(sp),W_FLAGS(a0)	;Get window flags
	bset.b		#WFB_ACTIVE,W_FLAGS(a0)	;Set window to "active"

	move.b		W_PRIORITY(a0),-(sp)	;List entry priority
	pea		W_HEADER(a0)		;*List entry
	move.l		#WindowList,-(sp)	;*List
	jsr		Prosit::List_Insert
	lea		10(sp),sp

	bsr		Calculate_Window
	bsr		Shift_Window
	bsr		Create_All_Masks

	PROSIT_UNLOCK	1
	bsr		Internal_Refresh_Window

	moveq		#0,d0			;Return "true"

\done	movem.l		(sp)+,a0-a3/d1-d3
	rts

;---------------------------------------------------------------------
; void WinClose(WINDOW *w)
;
; Function: Remove the window from the LCD.
;---------------------------------------------------------------------
WinClose:
winlib@0006:
	movem.l		a0-a3/d0-d2/d6-d7,-(sp)

	move.l		4+4*9(sp),a0		;*Window

	PROSIT_LOCK	1

	bclr.b		#WFB_ACTIVE,W_FLAGS(a0)	;Set window to "inactive"

	move.l		a0,a3
	cmp.l		WindowInFocus,a0
	bne.s		\nofoc			;Window wasn't in focus!
	move.l		W_NEXT(a0),a0		;Window was in focus
	lea		-W_HEADER(a0),a0
	bsr		Make_Window_Focus	;Give focus to next window in list

\nofoc	pea		W_HEADER(a3)
	move.l		#WindowList,-(sp)
	jsr		Prosit::List_Remove
	addq.l		#8,sp
	bsr		Create_All_Masks
	bsr		Refresh_LCD

	TOGGLE_PROSIT
	move.w		W_CONTENTS_HANDLE(a3),-(sp)
	jsr		doorsos::HeapFree
	move.w		W_SHIFTED_HANDLE(a3),(sp)
	jsr		doorsos::HeapFree
	move.w		W_MASK_HANDLE(a3),(sp)
	jsr		doorsos::HeapFree
	addq.l		#2,sp
	TOGGLE_PROSIT

\done	PROSIT_UNLOCK	1
	movem.l		(sp)+,a0-a3/d0-d2/d6-d7
	rts

;---------------------------------------------------------------------
; void WinSelect(WINDOW *w)
;
; Function: Select the window for drawing.
;---------------------------------------------------------------------
WinSelect:
winlib@0007:
	movem.l		a0/d0,-(sp)

	move.l		4+2*4(sp),a0

	move.w		W_WIDTH_IN_WORDS(a0),d0
	lsl.w		#4,d0
	subq.w		#1,d0
	swap		d0
	move.w		W_HEIGHT(a0),d0
	subq.w		#1,d0
	move.l		d0,-(sp)
	move.w		W_CONTENTS_HANDLE(a0),d0
	doorsos::DEREF	d0,a0
	pea		4(a0)
	jsr		doorsos::PortSet
	lea		8(sp),sp

	movem.l		(sp)+,a0/d0
	rts

;---------------------------------------------------------------------
; Move_Window(WINDOW *w, WORD xpos, WORD ypos)
;
; Function: Move the window to (xpos,ypos).
;---------------------------------------------------------------------
Move_Window:
winlib@0008:
	movem.l		a0/d0/d6,-(sp)

	move.l		4+12(sp),a0

	btst.b		#WFB_LOCKED,W_FLAGS(a0)
	bne.s		\locked			;WIndow is locked, can't move it!

	PROSIT_LOCK	1

	move.w		4+16(sp),W_X_POS(a0)
	move.w		4+18(sp),W_Y_POS(a0)

	bsr		Calculate_Window
	bsr		Shift_Window

	bsr		Create_All_Masks
	bsr		Refresh_LCD

	PROSIT_UNLOCK	1

\locked	movem.l		(sp)+,a0/d0/d6
	rts

;---------------------------------------------------------------------
; Refresh_Window(WINDOW *w)
;
; Function: Update the window's contents on the LCD.
;---------------------------------------------------------------------
Refresh_Window:
winlib@0009:
	PROSIT_LOCK	1

	movem.l		a0,-(sp)
	move.l		4+4(sp),a0

	bsr		Shift_Window
	bsr		Internal_Refresh_Window

	movem.l		(sp)+,a0

	PROSIT_UNLOCK	1
	rts

;*******************************************************
;* Internal Refresh_Window: Takes a0=*window as input. *
;*******************************************************
Internal_Refresh_Window:
	movem.l		a0-a6/d0-d7,-(sp)

	move.w		W_MASK_HANDLE(a0),d0
	doorsos::DEREF	d0,a2			;*Mask
	move.w		W_SHIFTED_WIDTH(a0),d5
	add.w		d5,a2	;*"Real" mask start

	moveq		#-1,d3			;Assume no mask change
	bsr		Disable_Mouse

;	HexShow		mmx,#10,#10,#7

	move.w		mmx,d0
	move.w		d0,d2
	move.w		W_X_POS(a0),d1
	bge.s		\wxpos
	moveq		#0,d1
\wxpos	sub.w		d1,d2			;MouseX - X = "MouseX in window"
	cmp.w		W_WIDTH(a0),d2
	bge		\nomod			;Mouse is entirely to the right of window, don't modify mask
	cmp.w		#-POINTER_WIDTH,d2
	ble		\nomod			;Mouse is entirely to the left of window, don't modify mask
	move.w		W_Y_POS(a0),d2
	bge.s		\wypos
	moveq		#0,d2
\wypos	neg.w		d2
	add.w		mmy,d2			;MouseY - Y  "MouseY in window"
	cmp.w		W_HEIGHT(a0),d2
	bge		\nomod			;Mouse is entirely below window, don't modify mask
	cmp.w		#-POINTER_HEIGHT,d2
	ble		\nomod			;Mouse is entirely above window, don't modify mask

	move.w		#POINTER_HEIGHT-1,d7	;No. of rows to change in window mask - 1
	moveq		#0,d6			;Row to start on in Mouse mask
	tst.w		d2		;RelY < 0?
	bge.s		\ypos
	add.w		d2,d7		;RelY < 0, reduce no. of rows to change mask on...
	sub.w		d2,d6		;...increase row to start on in mouse mask...
	moveq		#0,d2		;...and set row to start on in window to 0.
\ypos	move.w		d2,d3
	add.w		#POINTER_HEIGHT,d3
	sub.w		W_HEIGHT(a0),d3
	ble.s		\yok
	sub.w		d3,d7
\yok	lsl.w		#1,d6

	lsr.w		#3,d0		;MouseX / 8
	lsr.w		#3,d1		;W_X_POS / 8
	bclr.b		#0,d1		;Because windows are word-oriented
	sub.w		d1,d0		;(MouseX / 8) - (W_X_POS / 8)
	muls.w		d5,d2
	add.w		d0,d2		;Total offset in window contents and mask
	move.l		a2,a3
	lea		0(a3,d2.w),a3	;*Part of window mask where the mouse pointer is
	move.l		a3,\smc1+2	;Store thad address for when we restore the mask using smc =)

	move.w		W_SHIFTED_HANDLE(a0),d0
	doorsos::DEREF	d0,a6				;*Shifted contents
	lea		0(a6,d2.w),a6	;*Part of shifted window contents where the mouse pointer is

	move.l		#mmbuffer,a1
	lea		0(a1,d6.w),a1	;*Start of shifted mouse mask buffer
	move.l		#mbuffer,a5
	lea		0(a5,d6.w),a5	;*Start of mouse background storage buffer
	move.l		#mrbuffer,a4	;*Stored window mask
	move.w		d7,d3

\cmloop	move.b		(a3),d1		;Shifted window mask #1
	move.b		d1,(a4)+	;Store window mask #1
	move.b		(a6),d2		;Shifted window contents GFX #1
	and.b		d1,d2		;Mask shifted window contents GFX #1
	not.b		d1		;Invert shifted window mask #1
	and.b		d1,(a5)		;Mask mouse background storage buffer #1
	or.b		d2,(a5)+	;Add new gfx to mouse background storage buffer #1
	move.b		(a1)+,d0	;Shifted mouse mask #1
	and.b		d0,(a3)		;Remove mouse mask #1 part from window mask #1

	move.b		1(a3),d1	;Shifted window mask #2
	move.b		d1,(a4)+	;Store window mask #2
	move.b		1(a6),d2	;Shifted window contents GFX #2
	and.b		d1,d2		;Mask shifted window contents GFX #2
	not.b		d1		;Invert shifted window mask #2
	and.b		d1,(a5)		;Mask mouse background storage buffer #2
	or.b		d2,(a5)+	;Add new gfx to mouse background storage buffer #2
	move.b		(a1)+,d0	;Shifted mouse mask #2
	and.b		d0,1(a3)	;Remove mouse mask #2 part from window mask #2

	add.w		d5,a3		;Next row in shifted window mask
	add.w		d5,a6		;Next row in shifted window contents
	dbra.s		d7,\cmloop

\nomod	move.l		#LCD_MEM,a3
	move.w		W_LCD_START_OFFSET(a0),d0
	lea		0(a3,d0.w),a3			;*LCD start adress

	move.w		W_SHIFTED_HANDLE(a0),d0
	doorsos::DEREF	d0,a1				;*Shifted contents
	add.w		W_X_OFFSET_IN_CONTENTS(a0),a1	;*Shifted contents start
	move.w		W_ROWADD_LCD(a0),d4
	move.w		W_ROWADD_CONTENTS(a0),d5

	move.w		W_VISIBLE_ROWS(a0),d7
	subq.w		#1,d7
\rloop	move.w		W_VISIBLE_COLUMNS(a0),d6
\cloop	move.w		(a1)+,d0	;Window GFX
	move.w		(a2)+,d1	;Mask
	move.w		(a3),d2		;LCD GFX
	and.w		d1,d0		;Mask the window GFX
	not.w		d1
	and.w		d1,d2		;Mask the LCD GFX
	or.w		d2,d0		;Add the two together
	move.w		d0,(a3)+	;...and place the result on the LCD
	dbra.s		d6,\cloop
	add.w		d5,a1	;Contents RowAdd
	add.w		d5,a2	;Mask RowAdd = Contents RowAdd
	add.w		d4,a3	;LCD RowAdd
	dbra.s		d7,\rloop

	tst.w		d3
	blt.s		\done		;No of rows = 0 (-1)... mask wasn't modified.

	move.l		#mrbuffer,a4	;*Stored window mask
\smc1	move.l		#$12345678,a5	;a5 = *Where stored mask was taken from
	move.w		W_SHIFTED_WIDTH(a0),d5
\crloop	move.b		(a4)+,(a5)
	move.b		(a4)+,1(a5)
	add.w		d5,a5		;Next row
	dbra.s		d3,\crloop

\done	bsr		Enable_Mouse

	movem.l		(sp)+,a0-a6/d0-d7
	rts

;---------------------------------------------------------------------
; Move_Window_To_Front(WINDOW *w)
;
; Function: Move the window to the front.
;---------------------------------------------------------------------
Move_Window_To_Front:
winlib@000A:
	movem.l		a0/d6-d7,-(sp)

	move.l		4+12(sp),a0		;Window handle

	cmp.l		WindowInFocus,a0
	beq.s		\done			;Window is already in focus, do nothing.

	btst.b		#WFB_LOCKED,W_FLAGS(a0)
	bne.s		\done			;Window is locked, do nothing.

	PROSIT_LOCK	1
	bsr		Clear_Window_Focus
	bsr		Make_Window_Focus

	move.b		W_PRIORITY(a0),-(sp)
	pea		W_HEADER(a0)
	move.l		#WindowList,-(sp)
	jsr		Prosit::List_Remove
	jsr		Prosit::List_Insert
	lea		10(sp),sp

	bsr		Create_All_Masks
	bsr		Shift_Window
	bsr		Internal_Refresh_Window

	PROSIT_UNLOCK	1

\done	movem.l		(sp)+,a0/d6-d7
	rts

;***************************************************************************

;Remove focus from the window that currently has it.
Clear_Window_Focus:
	movem.l		a0-a1/d0/d6,-(sp)

	move.l		WindowInFocus,a0
	cmp.l		#0,a0
	beq.s		\nofoc
	move.l		WindowInFocus_Structure,a1
	cmp.l		#0,a1
	beq.s		\nofoc			;Window on top doesn't have any structure!
	move.l		8(a1),a1		;"Window lost focus" list
	cmp.l		#0,a1
	beq.s		\nofoc			;Window on top doesn't have any "lost focus" list!
	move.l		a1,-(sp)
	move.l		a0,-(sp)
	bsr		WinSelect
	bsr		DrawStructure		;Draw "lost focus" structure
	addq.l		#8,sp

	bsr		Shift_Window
	bsr		Internal_Refresh_Window

	clr.l		WindowInFocus

\nofoc	movem.l		(sp)+,a0-a1/d0/d6
	rts

;Put focus on window a0
Make_Window_Focus:
	movem.l		a0/d0/d6,-(sp)

	move.l		a0,WindowInFocus

	move.l		W_DATARETURN(a0),WindowInFocus_Return
	move.l		W_STRUCTURE(a0),a0
	move.l		a0,WindowInFocus_Structure
	cmp.l		#0,a0
	beq.s		\nofoc			;New window on top doesn't have structure!
	move.l		4(a0),a0		;"Window got focus" list
	cmp.l		#0,a0
	beq.s		\nofoc			;New window on top doesn't have any "got focus" list!
	move.l		a0,-(sp)
	move.l		WindowInFocus,-(sp)
	bsr		WinSelect
	bsr		DrawStructure
	addq.l		#8,sp

\nofoc	movem.l		(sp)+,a0/d0/d6
	rts


;******************************************
;* Refresh the background and all windows *
;******************************************
Refresh_LCD:
	movem.l		a0-a2/d0-d3,-(sp)

	move.l		WindowList,a0
	cmp.l		#0,a0
	beq		\done				;No windows to plot!

	move.l		a0,a1
\wloop	lea		-W_NEXT(a0),a0
	bsr		Internal_Refresh_Window
	move.l		W_NEXT(a0),a0
	cmp.l		a0,a1
	bne.s		\wloop

\done	movem.l		(sp)+,a0-a2/d0-d3
	rts

;***************************************************
;* Create masks for all windows and the background *
;***************************************************
Create_All_Masks:
	movem.l		a0-a6/d0-d7,-(sp)

	move.w		BkgWindow+W_MASK_HANDLE,d0

	doorsos::DEREF	d0,a6
	lea		32(a6),a6

	move.l		a6,a0
	move.w		#(32*SCREEN_HEIGHT)/4-1,d0
;	move.w		#(32*128)/4-1,d0
\cpy	move.l		#$FFFFFFFF,(a0)+
	dbra.s		d0,\cpy

	move.l		WindowList,a0
	cmp.l		#0,a0
	beq		\done				;No windows to make masks for!

\wloop	lea		-W_NEXT(a0),a0
	move.w		W_MASK_HANDLE(a0),d0

	cmp.w		BkgWindow+W_MASK_HANDLE,d0
	beq.s		\done

	doorsos::DEREF	d0,a2				;*Mask
	move.l		a2,a3
	add.w		W_SHIFTED_WIDTH(a0),a3		;*Start of "real" mask
	add.w		W_X_OFFSET_IN_CONTENTS(a0),a2	;*Start of preliminary mask row

;	move.l		#bg_mask,a5
	move.l		a6,a5
	add.w		W_LCD_START_OFFSET(a0),a5	;*LCD start of window

	move.w		W_Y_POS(a0),d0
	ble.s		\yneg
	lsl.w		#1,d0
	add.w		d0,a5
\yneg	move.w		W_VISIBLE_ROWS(a0),d6
	subq.w		#1,d6
	move.w		W_VISIBLE_COLUMNS(a0),d4
	move.w		W_ROWADD_LCD(a0),d3
	move.w		W_ROWADD_CONTENTS(a0),d1

\rloop	move.l		a2,a4
	move.w		d4,d5

\cloop	move.w		(a4)+,d0	;Window mask
	and.w		(a5),d0		;Mask window mask with LCD mask
	move.w		d0,(a3)+	;Store window mask
	eor.w		d0,(a5)+	;Remove window mask from LCD mask and store new LCD mask
	dbra.s		d5,\cloop

	lea		2(a5,d3.w),a5		;Go to the next LCD mask row
	lea		0(a3,d1.w),a3		;Go to the next window mask row
	dbra.s		d6,\rloop		;Next row

	move.l		W_NEXT(a0),a0
	bra		\wloop

\done	movem.l		(sp)+,a0-a6/d0-d7
	rts

;*******************************
;* Shift the GFX of a0=*window *
;*******************************
Shift_Window:
	movem.l		a0-a3/d0-d7,-(sp)

	move.w		W_CONTENTS_HANDLE(a0),d0
	doorsos::DEREF	d0,a1				;*Contents
	addq.l		#4,a1
	move.w		W_Y_OFFSET_IN_CONTENTS(a0),d0
	add.w		W_Y_OFFSET_IN_CONTENTS(a0),a1

	move.w		W_SHIFTED_HANDLE(a0),d0
	doorsos::DEREF	d0,a2

	move.w		W_SHIFT_AMOUNT(a0),d5

	move.w		W_VISIBLE_ROWS(a0),d7
	subq.w		#1,d7

\rloop	moveq		#0,d0
	move.w		(a1)+,d0
	ror.l		d5,d0
	move.w		d0,(a2)+		;First word on row
	swap		d0

\rstart	move.w		W_WIDTH_IN_WORDS(a0),d6
	subq.w		#2,d6
	blt.s		\nxtrow

\cloop	moveq		#0,d1
	move.w		(a1)+,d1
	ror.l		d5,d1
	or.w		d0,d1
	move.w		d1,(a2)+
	swap		d1
	move.w		d1,d0
	dbra.s		d6,\cloop

\nxtrow	move.w		d0,(a2)+		;Last word on row

	dbra.s		d7,\rloop

\done	movem.l		(sp)+,a0-a3/d0-d7
	rts


;***********************************************
;* Calculate shifting constants for a0=*window *
;***********************************************
Calculate_Window:
	movem.l		a0/d0-d7,-(sp)

	move.w		W_HEIGHT(a0),d1		;No. of rows visible
	move.w		W_WIDTH_IN_WORDS(a0),d2	;No. of columns visible

	move.w		d2,d3
	addq.w		#1,d3
	lsl.w		#1,d3
	move.w		d3,W_SHIFTED_WIDTH(a0)

	moveq		#0,d0			;Default Y offset=0
	move.w		W_Y_POS(a0),d7
	bge.s		\ypos		;Y is positive, no Y offset
	sub.w		d7,d0		;Y is negative, increase Y offset...
	mulu.w		d2,d0		;...and multiply with the width.
	add.w		d7,d1		;Y is negative, decrease no. of visible rows.
	moveq		#0,d7
\ypos	move.w		d7,d6
	mulu.w		#15,d6		;LCD offset in Y
	add.w		d1,d7
	sub.w		#SCREEN_HEIGHT,d7
	ble.s		\x		;Lower edge is on screen, continue to X calculations
	sub.w		d7,d1		;Lower edge is off screen, decrease no. of visible rows

\x	moveq		#0,d7			;Default Mask offset = 0
	move.w		W_X_POS(a0),d3
	asr.w		#4,d3
	bge.s		\xpos		;X is positive, no X offset
	add.w		d3,d2		;X is negative, decrease no. of visible columns
	sub.w		d3,d7		;X is negative, increase X offset
	moveq		#0,d3
\xpos	add.w		d3,d6		;LCD offset in X
	add.w		d2,d3
	sub.w		#14,d3
	ble.s		\done		;Right edge is on screen, continue
	sub.w		d3,d2		;Right edge is off screen, decrease no. of visible columns

\done	move.w		W_WIDTH_IN_WORDS(a0),d3	;RowAdd for original content - start with total width...
	sub.w		d2,d3			;...and subtract no. of visible columns.
	lsl.w		#1,d3			;Now RowAdd for original content is in bytes
	moveq		#15,d4		;RowAdd for LCD - start with total width...
	sub.w		d2,d4			;...and subtract no. of visible columns.
	lsl.w		#1,d4			;Now RowAdd for LCD is in bytes
	subq.w		#2,d4		;THIS WAS DONE BY INTERNAL_REFRESH_WINDOW *AND* CREATE_ALL_MASKS!

	lsl.w		#1,d0			;Now Y Offset in original contents is in bytes
	lsl.w		#1,d7			;Now X Offset in original contents is in bytes
	lsl.w		#1,d6			;Now LCD offset is in bytes

	move.w		W_X_POS(a0),d5		;Get x position again...
	and.w		#%0000000000001111,d5	;The relevant bits

;Now d0 = Y Offset in original contents
;    d1 = No. of visible rows
;    d2 = No. of visible columns
;    d3 = RowAdd for original content
;    d4 = RowAdd for LCD
;    d5 = Shift amount
;    d6 = Offset on LCD
;    d7 = X Offset in original contents

	movem.w		d0-d7,W_Y_OFFSET_IN_CONTENTS(a0)

	move.w		W_WIDTH_IN_WORDS(a0),d0		;Width in words
	move.w		d0,d1				;Store it
	lsl.w		#4,d1				;One word = 16 pixels
	sub.w		W_WIDTH(a0),d1			;Overflow pixels
	moveq		#0,d3
	bset.w		d1,d3				;Set bit
	subq.w		#1,d3				;Set all bits lower than bit
	not.w		d3				;Leftmost pixel = LSB

	cmp.w		#1,d0
	beq.s		\one
;More than one word wide
	move.w		d3,d1
	or.l		#$FFFF0000,d1
	lsr.l		d5,d1
	move.w		d1,d2
	swap		d1
	ror.l		d5,d3
	swap		d3
	bra.s		\done2

;One word wide, just use the edge gfx
\one	ror.l		d5,d3
	move.w		d3,d1
	swap		d3

;Now d1 = Left edge of mask
;    d2 = Left part of right edge of mask
;    d3 = Right part of right edge of mask

\done2	move.w		W_MASK_HANDLE(a0),d0
	doorsos::DEREF	d0,a1

;Create preliminary mask row:
;----------------------------
	move.w		d1,(a1)+
	move.w		W_WIDTH_IN_WORDS(a0),d0
	subq.w		#2,d0
	blt.s		\end2
	beq.s		\end1
	subq.w		#1,d0
\cloop	move.w		#$FFFF,(a1)+
	dbra.s		d0,\cloop

\end1	move.w		d2,(a1)+
\end2	move.w		d3,(a1)+

	movem.l		(sp)+,a0/d0-d7
	rts

;***************************************************************************









BUFFER_WIDTH	EQU	34
BUFFER_HEIGHT	EQU	12

	include		"winlib_g.asm"



;***************************************************************************


;****************************
;*                          *
;* MOUSEBUTTON CODE         *
;* DEAL WITH THE WINDOW GUI *
;*                          *
;****************************
	include		"winlib_s.asm"

;**********************************************************************
;*                             MOUSE CODE                             *
;**********************************************************************
	include		"winlib_m.asm"


	EVEN
BkgWinRect	dc.w	0,0,239,127
BkgWindow	ds.b	W_HEADER_SIZE

	BSS
WindowInFocus		dc.l	0
WindowInFocus_Return	dc.l	0
WindowInFocus_Structure	dc.l	0

BkgWindowHandle		dc.w	0
BkgWindowContentsHandle	dc.w	0
BkgWindowMaskHandle	dc.w	0

WindowList		dc.l	0

GUI_ManPart_Counter	dc.w	0

old_int5		dc.l	0
mbid			dc.w	0		;MouseButton process ID
mid			dc.w	0		;Mouse process ID
mbuffer			ds.l	POINTER_HEIGHT	;Mouse LCD background buffer
mmbuffer		ds.l	POINTER_HEIGHT	;Mouse shifted mask buffer
mrbuffer		ds.l	POINTER_HEIGHT	;Mouse window refresh mask change buffer
mmx			dc.w	0
mmy			dc.w	0
mRows			dc.w	0
msin			dc.b	0
msout			dc.b	0
mDelay			dc.b	0

	EVEN
buffer		ds.b	2+BUFFER_WIDTH*BUFFER_HEIGHT
buffer_m	ds.b	BUFFER_WIDTH*BUFFER_HEIGHT

	END
